/*
 * $Id$
 */

package org.codehaus.mojo.appassembler.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * Class GeneratorConfiguration.
 * 
 * @version $Revision$ $Date$
 */
public class GeneratorConfiguration implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field generator.
     */
    private String generator;

    /**
     * Field configuration.
     */
    private java.util.Properties configuration;

    /**
     * Field includes.
     */
    private java.util.List includes;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addConfiguration.
     * 
     * @param key
     * @param value
     */
    public void addConfiguration( String key, String value )
    {
        getConfiguration().put( key, value );
    } //-- void addConfiguration( String, String ) 

    /**
     * Method addInclude.
     * 
     * @param string
     */
    public void addInclude( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "GeneratorConfiguration.addIncludes(string) parameter must be instanceof " + String.class.getName() );
        }
        getIncludes().add( string );
    } //-- void addInclude( String ) 

    /**
     * Method getConfiguration.
     * 
     * @return java.util.Properties
     */
    public java.util.Properties getConfiguration()
    {
        if ( this.configuration == null )
        {
            this.configuration = new java.util.Properties();
        }
    
        return this.configuration;
    } //-- java.util.Properties getConfiguration() 

    /**
     * Get the generator field.
     * 
     * @return String
     */
    public String getGenerator()
    {
        return this.generator;
    } //-- String getGenerator() 

    /**
     * Method getIncludes.
     * 
     * @return java.util.List
     */
    public java.util.List getIncludes()
    {
        if ( this.includes == null )
        {
            this.includes = new java.util.ArrayList();
        }
    
        return this.includes;
    } //-- java.util.List getIncludes() 

    /**
     * Method removeInclude.
     * 
     * @param string
     */
    public void removeInclude( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "GeneratorConfiguration.removeIncludes(string) parameter must be instanceof " + String.class.getName() );
        }
        getIncludes().remove( string );
    } //-- void removeInclude( String ) 

    /**
     * Set the configuration field.
     * 
     * @param configuration
     */
    public void setConfiguration( java.util.Properties configuration )
    {
        this.configuration = configuration;
    } //-- void setConfiguration( java.util.Properties ) 

    /**
     * Set the generator field.
     * 
     * @param generator
     */
    public void setGenerator( String generator )
    {
        this.generator = generator;
    } //-- void setGenerator( String ) 

    /**
     * Set the platforms to be included in the generator. This is
     * currently only used in JSW generator. 
     *           Options are: "linux-ppc-64", "linux-x86-32",
     * "linux-x86-64", "macosx-ppc-32", "macosx-x86-universal-32", 
     *           "solaris-sparc-32", "solaris-sparc-64",
     * "solaris-x86-32", "windows-x86-32 
     *           .
     * 
     * @param includes
     */
    public void setIncludes( java.util.List includes )
    {
        this.includes = includes;
    } //-- void setIncludes( java.util.List ) 


    private String modelEncoding = "UTF-8";

    /**
     * Set an encoding used for reading/writing the model.
     *
     * @param modelEncoding the encoding used when reading/writing the model.
     */
    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    /**
     * @return the current encoding used when reading/writing this model.
     */
    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
